{
 "metadata": {
  "name": ""
 },
 "nbformat": 3,
 "nbformat_minor": 0,
 "worksheets": [
  {
   "cells": [
    {
     "cell_type": "heading",
     "level": 1,
     "metadata": {},
     "source": [
      "10: Specialized Lists"
     ]
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 1: Page 185"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "def insert(key):\t#insert, in order\n",
      "\tpNewLink = Link(key)\t#make new link\n",
      "\tpPrevious = None\t#start at first\n",
      "\tpCurrent = pFirst\n",
      "\t#until end of list,\n",
      "\twhile pCurrent and key > pCurrent.dData:\t#or key > current,\n",
      "\t\tpPrevious = pCurrent\n",
      "\t\tpCurrent = pCurrent.pNext\t#got to next item\n",
      "\tif not pPrevious:\t#at beginning of list\n",
      "\t\tpFirst = pNewLink\t#first --> newlink\n",
      "\telse:\t#not at begining\n",
      "\t\tpPrevious.pNext = pNewLink\t#old prev --> newLink\n",
      "\tpNewLink.pNext = pCurrent\t#newLink --> old current\n",
      "#end insert()"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [],
     "prompt_number": 1
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 2: Page 186"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "#demonstrates sorted list\n",
      "class Link:\n",
      "\n",
      "\tdef __init__(self, dd):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\t\tself.dData = dd\t#data item\n",
      "\t\tself.pNext = None\t#next link in list\n",
      "\t\t\n",
      "\tdef displayLink(self):\t#display this link\n",
      "\t\tprint self.dData,\n",
      "#end class Link\n",
      "\n",
      "class SortedList:\n",
      "\n",
      "\tdef __init__(self):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\n",
      "\t\t#as private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._pFirst = None\t#first link\n",
      "\n",
      "\tdef __del__(self):\t#destructor (deletes list)\n",
      "\t\tself.__init__()\n",
      "\n",
      "\tdef isEmpty(self):\t#true if no links\n",
      "\t\treturn self._pFirst == None\n",
      "\n",
      "\tdef insert(self, key):\t#insert, in order\n",
      "\t\tpNewLink = Link(key)\t#make new link\n",
      "\t\tpPrevious = None\t#start at first\n",
      "\t\tpCurrent = self._pFirst\n",
      "\t\t#until end of list,\n",
      "\t\twhile pCurrent and key > pCurrent.dData:\t#or key > current,\n",
      "\t\t\tpPrevious = pCurrent\n",
      "\t\t\tpCurrent = pCurrent.pNext\t#got to next item\n",
      "\t\tif not pPrevious:\t#at beginning of list\n",
      "\t\t\tself._pFirst = pNewLink\t#first --> newlink\n",
      "\t\telse:\t#not at begining\n",
      "\t\t\tpPrevious.pNext = pNewLink\t#old prev --> newLink\n",
      "\t\tpNewLink.pNext = pCurrent\t#newLink --> old current\n",
      "\t#end insert()\n",
      "\n",
      "\tdef remove(self):\t#remove first link\n",
      "\t\t#(assumes non-empty list)\n",
      "\t\tpTemp = self._pFirst\t#save first\n",
      "\t\tself._pFirst = self._pFirst.pNext\t#new first-->next\n",
      "\t\tdel pTemp\t#delete old first link\n",
      "\t\t\n",
      "\tdef displayList(self):\n",
      "\t\tprint\n",
      "\t\tprint 'List (first-->last):',\n",
      "\t\tpCurrent = self._pFirst\t#start at beginning of list\n",
      "\t\twhile pCurrent:\t#until end of list,\n",
      "\t\t\tpCurrent.displayLink()\t#print data\n",
      "\t\t\tpCurrent = pCurrent.pNext\t#move to next link\n",
      "#end class SortedList\n",
      "\n",
      "theSortedList = SortedList()\t#create new list\n",
      "theSortedList.insert(20)\t#insert 2 items\n",
      "theSortedList.insert(40)\n",
      "\n",
      "theSortedList.displayList()\t#display list (20, 40)\n",
      "\n",
      "theSortedList.insert(10)\t#insert 3 more items\n",
      "theSortedList.insert(30)\n",
      "theSortedList.insert(50)\n",
      "\n",
      "theSortedList.displayList()\t#display list\n",
      "\t#\t(10, 20, 30, 40, 50)\n",
      "theSortedList.remove()\t#remove smallest item\n",
      "\n",
      "theSortedList.displayList()\t#display list (20, 30, 40, 50)\n",
      "#end"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "\n",
        "List (first-->last): 20 40\n",
        "List (first-->last): 10 20 30 40 50\n",
        "List (first-->last): 20 30 40 50\n"
       ]
      }
     ],
     "prompt_number": 2
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 3: Page 190"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "#demonstrates sorted list used for sorting\n",
      "from pylab import array\n",
      "from random import randrange\t#for random numbers\n",
      "\n",
      "class Link:\n",
      "\n",
      "\tdef __init__(self, dd):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\t\tself.dData = dd\t#data item\n",
      "\t\tself.pNext = None\t#next link in list\n",
      "\n",
      "class SortedList:\n",
      "\n",
      "\tdef __init__(self, linkArr, length):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\n",
      "\t\t#as private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._pFirst = None\t#first item on list\n",
      "\t\tfor j in xrange(length):\t#copy array\n",
      "\t\t\tself.insert(linkArr[j])\t#to list\n",
      "\n",
      "\tdef insert(self, pArg):\t#insert (in order)\n",
      "\t\tpPrevious = None\t#start at first\n",
      "\t\tpCurrent = self._pFirst\n",
      "\t\t#until end of list,\n",
      "\t\twhile pCurrent and pArg.dData > pCurrent.dData:\t#or key > current,\n",
      "\t\t\tpPrevious = pCurrent\n",
      "\t\t\tpCurrent = pCurrent.pNext\t#go to next item\n",
      "\t\tif not pPrevious:\t#at beginning of list\n",
      "\t\t\tself._pFirst = pArg\t#first --> k\n",
      "\t\telse:\t#not at begining\n",
      "\t\t\tpPrevious.pNext = pArg\t#old prev --> k\n",
      "\t\tpArg.pNext = pCurrent\t#k --> old current\n",
      "\t#end insert()\n",
      "\n",
      "\tdef remove(self):\t#return & delete first link\n",
      "\t\t#(assumes non-empty list)\n",
      "\t\tpTemp = self._pFirst\t#save first\n",
      "\t\tself._pFirst = self._pFirst.pNext\t#delete first\n",
      "\t\treturn pTemp\t#return value\n",
      "#end class SortedList\n",
      "\n",
      "size = 10#array size\n",
      "linkArray = array([None] * 10)\t#array for links\n",
      "\n",
      "for j in xrange(size):\t#fill with links\n",
      "\tn = randrange(0, 100)\t#random number (0 to 99)\n",
      "\tpNewLink = Link(n)\t#make link\n",
      "\tlinkArray[j] = pNewLink\t#put link in array\n",
      "\n",
      "print 'Unsorted array:',\t#display array contents\n",
      "for j in linkArray:\n",
      "\tprint j.dData,\n",
      "\n",
      "theSortedList = SortedList(linkArray, size)\t#create new list\n",
      "\n",
      "for j in xrange(size):\t#links from list to array\n",
      "\tlinkArray[j] = theSortedList.remove()\n",
      "\n",
      "print\n",
      "print 'Sorted Array:',\t#display array contents\n",
      "for j in linkArray:\n",
      "\tprint j.dData,\n",
      "\n",
      "del linkArray\t#delete links"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "Unsorted array: 16 40 89 88 85 8 47 92 95 5\n",
        "Sorted Array: 5 8 16 40 47 85 88 89 92 95\n"
       ]
      }
     ],
     "prompt_number": 3
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 4: Page 194"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "def insertFirst(dd):\t#insert at front of list\n",
      "\tpNewLink = Link(dd)\t#make new link\n",
      "\n",
      "\tif isEmpty():\t#if empty list,\n",
      "\t\tpLast = pNewLink\t#newLink <-- last\n",
      "\telse:\n",
      "\t\tpFirst.pPrevious = pNewLink\t#newLink <-- old first\n",
      "\tpNewLink.pNext = pFirst\t#newLink --> old first\n",
      "\tpFirst = pNewLink\t#first --> newLink"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [],
     "prompt_number": 4
    },
    {
     "cell_type": "heading",
     "level": 2,
     "metadata": {},
     "source": [
      "Example 5: Page 197"
     ]
    },
    {
     "cell_type": "code",
     "collapsed": false,
     "input": [
      "#demonstrates doubly-linked list\n",
      "\n",
      "class Link:\n",
      "\n",
      "\tdef __init__(self, dd):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\t\tself.dData = dd#data item\n",
      "\t\tself.pNext = None\t#next link in list\n",
      "\t\tself.pPrevious = None\t#previous link in list\n",
      "\n",
      "\tdef displayLink(self):\t#display this link\n",
      "\t\tprint self.dData,\n",
      "\n",
      "class DoublyLinkedList:\n",
      "\tdef __init__(self):\t#special method to create objects\n",
      "\t#with instances customized to a specific initial state\n",
      "\n",
      "\t\t#as private instance variables don't exist in Python,\n",
      "\t\t#hence using a convention: name prefixed with an underscore, to treat them as non-public part\n",
      "\t\tself._pFirst = None\t#pointer to first item\n",
      "\t\tself._pLast = None\t#pointer to last item\n",
      "\n",
      "\tdef __del__(self):\t#destructor (deletes list)\n",
      "\t\tself.__init__()\n",
      "\n",
      "\tdef isEmpty(self):\t#true if no links\n",
      "\t\treturn self._pFirst == None\n",
      "\n",
      "\tdef insertFirst(self, dd):\t#insert at front of list\n",
      "\t\tpNewLink = Link(dd)\t#make new link\n",
      "\n",
      "\t\tif self.isEmpty():\t#if empty list,\n",
      "\t\t\tself._pLast = pNewLink\t#newLink <-- last\n",
      "\t\telse:\n",
      "\t\t\tself._pFirst.pPrevious = pNewLink\t#newLink <-- old first\n",
      "\t\tpNewLink.pNext = self._pFirst\t#newLink --> old first\n",
      "\t\tself._pFirst = pNewLink\t#first --> newLink\n",
      "\n",
      "\tdef insertLast(self, dd):\t#insert at end of list\n",
      "\t\tpNewLink = Link(dd)\t#make new link\n",
      "\n",
      "\t\tif self.isEmpty():\t#if empty list,\n",
      "\t\t\tself._pFirst = pNewLink\t#first --> newLink\n",
      "\t\telse:\n",
      "\t\t\tself._pLast.pNext = pNewLink\t#old last --> newLink\n",
      "\t\t\tpNewLink.pPrevious = self._pLast\t#old last <-- newLink\n",
      "\t\tself._pLast = pNewLink\t#newLink <-- last\n",
      "\n",
      "\tdef removeFirst(self):\t#remove first link\n",
      "\t\tpTemp = self._pFirst\t#(assumes non-empty list)\n",
      "\t\tif not self._pFirst.pNext:\t#if only one item\n",
      "\t\t\tself._pLast = None#none <-- last\n",
      "\t\telse:\n",
      "\t\t\tself._pFirst.pNext.pPrevious = None#none <-- old next\n",
      "\t\tself._pFirst = self._pFirst.pNext\t#first --> old next\n",
      "\t\tdel pTemp\t#delete old first\n",
      "\n",
      "\tdef removeLast(self):\t#remove last link\n",
      "\t\tpTemp = self._pLast\t#assumes non-empty list\n",
      "\t\tif not self._pFirst.pNext:\t#if only one item\n",
      "\t\t\tself._pFirst = None#first --> none\n",
      "\t\telse:\n",
      "\t\t\tself._pLast.pPrevious.pNext = None#old previous --> none\n",
      "\t\tself._pLast = self._pLast.pPrevious\t#old previous <-- last\n",
      "\t\tdel pTemp\t#delete old last\n",
      "\n",
      "\t\t#insert dd just after key\n",
      "\tdef insertAfter(self, key, dd):\n",
      "\t\t\t#(assumes non-empty list)\n",
      "\t\tpCurrent = self._pFirst\t#start at beginning\n",
      "\t\twhile pCurrent.dData != key:\t#until match is found,\n",
      "\t\t\tpCurrent = pCurrent.pNext\t#move to next link\n",
      "\t\t\tif not pCurrent:\n",
      "\t\t\t\treturn False\t#didn't find it\n",
      "\t\tpNewLink = Link(dd)\t#make new link\n",
      "\n",
      "\t\tif pCurrent == self._pLast:\t#if last link,\n",
      "\t\t\tpNewLink.pNext = None#newLink --> none\n",
      "\t\t\tself._pLast = pNewLink\t#newLink <-- last\n",
      "\t\telse:\t#not last link,\n",
      "\t\t\t#newLink --> old next\n",
      "\t\t\tpNewLink.pNext = pCurrent.pNext\n",
      "\t\t\t#newLink <-- old next\n",
      "\t\t\tpCurrent.pNext.pPrevious = pNewLink\n",
      "\t\tpNewLink.pPrevious = pCurrent\t#old current <-- newLink\n",
      "\t\tpCurrent.pNext = pNewLink\t#old current --> newLink\n",
      "\t\treturn True#found it, did insertion\n",
      "\n",
      "\tdef removeKey(self, key):\t#remove item w/ givem key\n",
      "\t\t#(assumes nn-empty list)\n",
      "\t\tpCurrent = self._pFirst\t#start at beginning\n",
      "\t\twhile pCurrent.dData != key:\t#until match is found,\n",
      "\t\t\tpCurrent = pCurrent.pNext\t#move to next link\n",
      "\t\t\tif not pCurrent:\n",
      "\t\t\t\treturn False\t#didn't find it\n",
      "\t\tif pCurrent == self._pFirst:\t#found it; first item?\n",
      "\t\t\tself._pFirst = pCurrent.pNext\t#first --> old next\n",
      "\t\telse:\t#not first\n",
      "\t\t\t#old previous --> old next\n",
      "\t\t\tpCurrent.pPrevious.pNext = pCurrent.pNext\n",
      "\n",
      "\t\tif pCurrent == self._pLast:\t#last item?\n",
      "\t\t\tself._pLast = pCurrent.pPrevious\t#old previous <-- last\n",
      "\t\telse:\t#not last\n",
      "\t\t\t#old previous <-- old next\n",
      "\t\t\tpCurrent.pNext.pPrevious = pCurrent.pPrevious\n",
      "\t\tdel pCurrent\t#delete item\n",
      "\t\treturn True#successful deletion\n",
      "\n",
      "\tdef displayForward(self):\n",
      "\t\tprint 'List (first-->last):',\n",
      "\t\tpCurrent = self._pFirst\t#start at beginning\n",
      "\t\twhile pCurrent:\t#until end of list,\n",
      "\t\t\tpCurrent.displayLink()\t#display data\n",
      "\t\t\tpCurrent = pCurrent.pNext\t#move to next link\n",
      "\t\tprint\n",
      "\n",
      "\tdef displayBackward(self):\n",
      "\t\tprint 'List (first-->last):',\n",
      "\t\tpCurrent = self._pLast\t#start at end\n",
      "\t\twhile pCurrent:\t#until start of list,\n",
      "\t\t\tpCurrent.displayLink()\t#display data\n",
      "\t\t\tpCurrent = pCurrent.pPrevious\t#go to previous link\n",
      "\t\tprint\n",
      "#end class DoublyLinkedList\n",
      "\n",
      "theList = DoublyLinkedList()\t#make a new list\n",
      "\n",
      "theList.insertFirst(22)\t#insert at front\n",
      "theList.insertFirst(44)\n",
      "theList.insertFirst(66)\n",
      "\n",
      "theList.insertLast(11)\t#insert at rear\n",
      "theList.insertLast(33)\n",
      "theList.insertLast(55)\n",
      "\n",
      "theList.displayForward()\t#display list forward\n",
      "theList.displayBackward()\t#display list backward\n",
      "\n",
      "print 'Deleting first, last, and 11'\n",
      "theList.removeFirst()\t#remove first item\n",
      "theList.removeLast()\t#remove last item\n",
      "theList.removeKey(11)\t#remove item with key 11\n",
      "\n",
      "\n",
      "theList.displayForward()\t#display list forward\n",
      "\n",
      "print 'Inserting 77 after 22, and 88 after 33'\n",
      "theList.insertAfter(22, 77)\t#insert 77 after 22\n",
      "theList.insertAfter(33, 88)\t#insert 88 after 33\n",
      "\n",
      "theList.displayForward()\t#display list forward"
     ],
     "language": "python",
     "metadata": {},
     "outputs": [
      {
       "output_type": "stream",
       "stream": "stdout",
       "text": [
        "List (first-->last): 66 44 22 11 33 55\n",
        "List (first-->last): 55 33 11 22 44 66\n",
        "Deleting first, last, and 11\n",
        "List (first-->last): 44 22 33\n",
        "Inserting 77 after 22, and 88 after 33\n",
        "List (first-->last): 44 22 77 33 88\n"
       ]
      }
     ],
     "prompt_number": 5
    }
   ],
   "metadata": {}
  }
 ]
}